var NAVTREE =
[
  [ "GNU Radio 3.7.1 C++ API", "index.html", [
    [ "Building GNU Radio", "index.html#build", null ],
    [ "GNU Radio Blocks", "index.html#blocks", null ],
    [ "Manual Contents", "index.html#toc", null ],
    [ "Operating a Flowgraph", "index.html#flowgraph", [
      [ "Latency and Throughput", "index.html#latency", null ]
    ] ],
    [ "Reconfiguring Flowgraphs", "index.html#reconfigure", null ],
    [ "Using Volk in GNU Radio", "index.html#volk_main", null ],
    [ "Configuration / Preference Files", "index.html#prefs", null ],
    [ "Out-of-Tree Configuration", "index.html#oot_config_page", [
      [ "Install Path", "index.html#oot_config_path_page", null ]
    ] ],
    [ "ControlPort", "page_ctrlport.html", [
      [ "Introduction", "page_ctrlport.html#Introduction", null ],
      [ "Dependencies", "page_ctrlport.html#Dependencies", null ],
      [ "Configuration", "page_ctrlport.html#conf", null ],
      [ "Using ControlPort to Export Variables", "page_ctrlport.html#using", [
        [ "Alternative Registers", "page_ctrlport.html#alt_reg", null ]
      ] ],
      [ "Display Options", "page_ctrlport.html#disp", null ],
      [ "ControlPort Probes", "page_ctrlport.html#probes", null ],
      [ "ControlPort Monitors", "page_ctrlport.html#monitors", [
        [ "Performance Monitor", "page_ctrlport.html#perfmonitor", null ]
      ] ]
    ] ],
    [ "Build Instructions and Information", "build_guide.html", [
      [ "Dependencies", "build_guide.html#dependencies", [
        [ "Global Dependencies", "build_guide.html#dep_global", null ],
        [ "Python Wrappers", "build_guide.html#dep_python", null ],
        [ "docs: Building the documentation", "build_guide.html#dep_docs", null ],
        [ "grc: The GNU Radio Companion", "build_guide.html#dep_grc", null ],
        [ "gr-wavelet: Collection of wavelet blocks", "build_guide.html#dep_wavelet", null ],
        [ "gr-qtgui: The QT-based Graphical User Interface", "build_guide.html#dep_gr_qtgui", null ],
        [ "gr-wxgui: The WX-based Graphical User Interface", "build_guide.html#dep_gr_wxgui", null ],
        [ "gr-audio: Audio Subsystems (system/OS dependent)", "build_guide.html#dep_gr_audio", null ],
        [ "uhd: The Ettus USRP Hardware Driver Interface", "build_guide.html#dep_uhd", null ],
        [ "gr-video-sdl: PAL and NTSC display", "build_guide.html#dep_gr_video_sdl", null ],
        [ "gr-comedi: Comedi hardware interface", "build_guide.html#dep_gr_comedi", null ],
        [ "gr-log: Logging Tools (Optional)", "build_guide.html#dep_gr_log", null ]
      ] ],
      [ "Building GNU Radio", "build_guide.html#build_gr_cmake", [
        [ "Options", "build_guide.html#Cmake", null ],
        [ "Building for the E100", "build_guide.html#build_gr_cmake_e100", null ]
      ] ]
    ] ],
    [ "Instructions for using Volk in GNU Radio", "volk_guide.html", [
      [ "Introduction", "volk_guide.html#volk_intro", null ],
      [ "Setting and Using Memory Alignment Information", "volk_guide.html#volk_alignment", null ],
      [ "Using Alignment Properties in Work()", "volk_guide.html#volk_work", null ],
      [ "Tuning Volk Performance", "volk_guide.html#volk_tuning", [
        [ "Hand-Tuning Performance", "volk_guide.html#volk_hand_tuning", null ]
      ] ]
    ] ],
    [ "Logging", "page_logger.html", [
      [ "Logging", "page_logger.html#logging", [
        [ "Logging Configuration", "page_logger.html#configfile", null ],
        [ "Advanced Configuration Options", "page_logger.html#adv_config", null ]
      ] ],
      [ "Advanced Usage", "page_logger.html#advlog", null ],
      [ "Logging from Python", "page_logger.html#logPy", null ]
    ] ],
    [ "Metadata Information", "page_metadata.html", [
      [ "Introduction", "page_metadata.html#Introduction", [
        [ "Types of Metadata Files", "page_metadata.html#types", null ],
        [ "Updating Headers", "page_metadata.html#updating", null ],
        [ "Implementation", "page_metadata.html#implementation", null ]
      ] ],
      [ "Structure", "page_metadata.html#structure", [
        [ "Header Information", "page_metadata.html#header", null ],
        [ "Extras Information", "page_metadata.html#extras", null ]
      ] ],
      [ "Utilities", "page_metadata.html#Utilities", null ],
      [ "Examples", "page_metadata.html#Examples", null ]
    ] ],
    [ "Message Passing", "page_msg_passing.html", [
      [ "Introduction", "page_msg_passing.html#intro", null ],
      [ "Message Passing API", "page_msg_passing.html#api", [
        [ "Message Handler Functions", "page_msg_passing.html#msg_handler", null ],
        [ "Connecting Messages through the Flowgraph", "page_msg_passing.html#msg_fg_connect", null ]
      ] ],
      [ "Examples", "page_msg_passing.html#examples", null ],
      [ "Posting from External Sources", "page_msg_passing.html#posting", null ]
    ] ],
    [ "OFDM", "page_ofdm.html", [
      [ "Introduction", "page_ofdm.html#intro", null ],
      [ "Conventions and Notations", "page_ofdm.html#conventions", [
        [ "FFT Shifting", "page_ofdm.html#fftshift", null ],
        [ "Carrier Indexing", "page_ofdm.html#indexing", null ],
        [ "Carrier and Symbol Allocation", "page_ofdm.html#carrieralloc", null ]
      ] ],
      [ "Detection and Synchronisation", "page_ofdm.html#detectsync", null ],
      [ "Transmitting", "page_ofdm.html#tx", null ],
      [ "Receiving", "page_ofdm.html#rx", null ]
    ] ],
    [ "Packet Data Transmission", "page_packet_data.html", [
      [ "Introduction", "page_packet_data.html#intro", null ],
      [ "Structure of a packet", "page_packet_data.html#packetstructure", null ],
      [ "The Header/Payload Demuxer and header parser", "page_packet_data.html#hpdemuxer", null ],
      [ "Packet receiver example: OFDM", "page_packet_data.html#ofdm", null ]
    ] ],
    [ "Performance Counters", "page_perf_counters.html", [
      [ "Introduction", "page_perf_counters.html#Introduction", null ],
      [ "Compile-time and Run-time Configuration", "page_perf_counters.html#pc_config", [
        [ "Compile-time Config", "page_perf_counters.html#pc_config_compile", null ],
        [ "Run-time Config", "page_perf_counters.html#pc_config_runtime", null ]
      ] ],
      [ "Performance Monitor", "page_perf_counters.html#pc_perfmonitor", null ]
    ] ],
    [ "Polyphase Filterbanks", "page_pfb.html", [
      [ "Introduction", "page_pfb.html#Introduction", null ],
      [ "Usage", "page_pfb.html#Usage", null ],
      [ "Examples", "page_pfb.html#Examples", null ],
      [ "The PFB Arbitrary Resampler Kernel", "page_pfb.html#pfb_arb_resampl", null ]
    ] ],
    [ "Polymorphic Types", "page_pmt.html", [
      [ "Introduction", "page_pmt.html#intro", null ],
      [ "PMT Data Type", "page_pmt.html#datatype", null ],
      [ "Inserting and Extracting Data", "page_pmt.html#insert", null ],
      [ "Strings", "page_pmt.html#strings", null ],
      [ "Tests and Comparisons", "page_pmt.html#tests", null ],
      [ "Dictionaries", "page_pmt.html#dict", null ],
      [ "Vectors", "page_pmt.html#vectors", [
        [ "BLOB", "page_pmt.html#blob", null ]
      ] ],
      [ "Pairs", "page_pmt.html#pairs", null ],
      [ "Serializing and Deserializing", "page_pmt.html#serdes", null ],
      [ "Printing", "page_pmt.html#printing", null ]
    ] ],
    [ "Stream Tags", "page_stream_tags.html", [
      [ "Introduction", "page_stream_tags.html#Introduction", null ],
      [ "API Extensions to the gr::block", "page_stream_tags.html#block_api_extensions", null ],
      [ "Stream Tags API", "page_stream_tags.html#stream_tags_api", [
        [ "Adding a Tag to a Stream", "page_stream_tags.html#add_item_tag", null ],
        [ "Getting tags from a Stream", "page_stream_tags.html#get_item_tags", null ]
      ] ],
      [ "Tag Propagation", "page_stream_tags.html#tag_propagation", [
        [ "Tag Propagation through Rate Changes", "page_stream_tags.html#tags_rate_changes", null ]
      ] ],
      [ "Notes on How to Use Tags", "page_stream_tags.html#tags_issues", null ]
    ] ],
    [ "Tagged Stream Blocks", "page_tagged_stream_blocks.html", [
      [ "Introduction", "page_tagged_stream_blocks.html#intro", [
        [ "How do they work?", "page_tagged_stream_blocks.html#howtheywork", null ],
        [ "How do they relate to other block types (e.g. sync blocks)?", "page_tagged_stream_blocks.html#relatestootherblocks", null ]
      ] ],
      [ "Creating a tagged stream block", "page_tagged_stream_blocks.html#creating", [
        [ "A note on tag propagation", "page_tagged_stream_blocks.html#note_on_tp", null ]
      ] ],
      [ "Advanced Usage", "page_tagged_stream_blocks.html#adv_usage", [
        [ "Multiple length tags", "page_tagged_stream_blocks.html#multiplelentags", null ],
        [ "Falling back to gr_block behaviour", "page_tagged_stream_blocks.html#backtogrblock", null ],
        [ "Other ways to determine the number of input items", "page_tagged_stream_blocks.html#otherwaysdetermineninput", null ]
      ] ],
      [ "Examples", "page_tagged_stream_blocks.html#examples", [
        [ "CRC32", "page_tagged_stream_blocks.html#CRC32", null ],
        [ "OFDM Frame Equalizer", "page_tagged_stream_blocks.html#ofdmeq", null ],
        [ "Tagged Stream Muxer", "page_tagged_stream_blocks.html#muxer", null ],
        [ "Cyclic Prefixer (OFDM)", "page_tagged_stream_blocks.html#ofdmprefixer", null ]
      ] ]
    ] ],
    [ "Block Thread Affinity", "page_affinity.html", [
      [ "Introduction", "page_affinity.html#intro", null ],
      [ "GNU Radio Block API", "page_affinity.html#affinity_api", [
        [ "Setting Affinity for a gr::hier_block2", "page_affinity.html#affinity_api_hier", null ],
        [ "GRC Access", "page_affinity.html#affinity_api_grc", null ]
      ] ]
    ] ],
    [ "Analog Modulation", "page_analog.html", [
      [ "Introduction", "page_analog.html#Introduction", null ]
    ] ],
    [ "Audio Interface", "page_audio.html", [
      [ "Introduction", "page_audio.html#Introduction", null ],
      [ "Usage", "page_audio.html#Usage", null ]
    ] ],
    [ "Digital Modulation", "page_digital.html", [
      [ "Introduction", "page_digital.html#Introduction", null ]
    ] ],
    [ "Channel Model Blocks", "page_channels.html", [
      [ "Introduction", "page_channels.html#Introduction", null ],
      [ "Available Channel Models", "page_channels.html#channels_types", [
        [ "AWGN Channel", "page_channels.html#channels_awgn", null ],
        [ "Fading Channel Model", "page_channels.html#channels_fading", null ],
        [ "Frequency-Selective Fading Model", "page_channels.html#channels_selective_fading", null ],
        [ "Hardware Impairments Model", "page_channels.html#channels_hw_impairments", null ]
      ] ]
    ] ],
    [ "FunCube Dongle Source", "page_fcd.html", [
      [ "Introduction", "page_fcd.html#Introduction", null ],
      [ "Dependencies", "page_fcd.html#Dependencies", null ]
    ] ],
    [ "Forward Error Correction", "page_fec.html", [
      [ "Introduction", "page_fec.html#Introduction", null ]
    ] ],
    [ "FFT Signal Processing Blocks", "page_fft.html", [
      [ "Introduction", "page_fft.html#Introduction", null ],
      [ "Dependencies", "page_fft.html#Dependencies", null ]
    ] ],
    [ "filter Signal Processing Blocks", "page_filter.html", [
      [ "Introduction", "page_filter.html#Introduction", null ],
      [ "Dependencies", "page_filter.html#Dependencies", null ]
    ] ],
    [ "QT Graphical User Interface", "page_qtgui.html", [
      [ "Introduction", "page_qtgui.html#Introduction", [
        [ "Blocks", "page_qtgui.html#Blocks", null ]
      ] ],
      [ "Dependencies", "page_qtgui.html#Dependencies", null ],
      [ "Usage", "page_qtgui.html#Usage", null ]
    ] ],
    [ "UHD Interface", "page_uhd.html", [
      [ "Introduction", "page_uhd.html#Introduction", null ],
      [ "Documentation", "page_uhd.html#External", null ],
      [ "Setup", "page_uhd.html#Typical", null ]
    ] ],
    [ "Voice Coders and Decoders (Vocoders)", "page_vocoder.html", [
      [ "Introduction", "page_vocoder.html#Introduction", null ]
    ] ],
    [ "Modules", "modules.html", "modules" ],
    [ "Namespaces", null, [
      [ "Namespace List", "namespaces.html", "namespaces" ],
      [ "Namespace Members", "namespacemembers.html", [
        [ "All", "namespacemembers.html", "namespacemembers_dup" ],
        [ "Functions", "namespacemembers_func.html", "namespacemembers_func" ],
        [ "Variables", "namespacemembers_vars.html", null ],
        [ "Typedefs", "namespacemembers_type.html", null ],
        [ "Enumerations", "namespacemembers_enum.html", null ],
        [ "Enumerator", "namespacemembers_eval.html", null ]
      ] ]
    ] ],
    [ "Classes", null, [
      [ "Class List", "annotated.html", "annotated" ],
      [ "Class Index", "classes.html", null ],
      [ "Class Hierarchy", "hierarchy.html", "hierarchy" ],
      [ "Class Members", "functions.html", [
        [ "All", "functions.html", "functions_dup" ],
        [ "Functions", "functions_func.html", "functions_func" ],
        [ "Variables", "functions_vars.html", "functions_vars" ],
        [ "Typedefs", "functions_type.html", "functions_type" ],
        [ "Enumerations", "functions_enum.html", null ],
        [ "Enumerator", "functions_eval.html", null ],
        [ "Properties", "functions_prop.html", null ],
        [ "Related Functions", "functions_rela.html", null ]
      ] ]
    ] ],
    [ "Files", null, [
      [ "File List", "files.html", "files" ],
      [ "File Members", "globals.html", [
        [ "All", "globals.html", "globals_dup" ],
        [ "Functions", "globals_func.html", "globals_func" ],
        [ "Variables", "globals_vars.html", "globals_vars" ],
        [ "Typedefs", "globals_type.html", null ],
        [ "Enumerations", "globals_enum.html", null ],
        [ "Enumerator", "globals_eval.html", null ],
        [ "Macros", "globals_defs.html", "globals_defs" ]
      ] ]
    ] ]
  ] ]
];

var NAVTREEINDEX =
[
"ConstellationDisplayPlot_8h.html",
"classConstellationDisplayPlot.html",
"classDisplayPlot.html#af6da5aafd94356af7d0fec57e3dca168",
"classGrAtscFieldSyncCorrelator.html#a21a11fa50d796a10bf10fbb60c330060",
"classQwtDblClickPlotPicker.html",
"classWaterfallDisplayForm.html#a5288da2e91b98868476ba8a693b8ae08",
"classatsci__equalizer__nop.html#a2d21e46afdfcd4dd3ff753d104e51a6f",
"classgr_1_1analog_1_1fmdet__cf.html#aff5e2b9af555bc1c12c994689364b303",
"classgr_1_1basic__block.html#a6e85f514a6c99d39593f0d250e787d2b",
"classgr_1_1blocks_1_1annotator__1to1.html#a51e118dc2fb0280e426dd5385eae3e24",
"classgr_1_1blocks_1_1head.html",
"classgr_1_1blocks_1_1threshold__ff.html",
"classgr_1_1digital_1_1constellation__calcdist.html#aa036a13b2028bfc9f05dd097c52a7c46",
"classgr_1_1digital_1_1ofdm__equalizer__static.html#a24e7ca2554d40ec98ef87d1827fbd98b",
"classgr_1_1fft_1_1fft__real__fwd.html#a3a09dd0f786f399c856eda17f42777ef",
"classgr_1_1filter_1_1kernel_1_1fir__filter__fff.html#ae5a42dd21472f9f3044d178112911e52",
"classgr_1_1fxpt.html#a03438d71c805e28baa7ac57908ecdcde",
"classgr_1_1pager_1_1flex__deinterleave.html#a90824ed1f483f4c527a7ff864571f828",
"classgr_1_1qtgui_1_1histogram__sink__f.html#a088a9efe1e1c265bd735ab8e08249fd0",
"classgr_1_1qtgui_1_1time__raster__sink__f.html#afdb641cc7744743688376c677c50a648",
"classgr_1_1qtgui_1_1waterfall__sink__f.html#aff3818c7d588ae0af5c5680c797c85de",
"classgr_1_1uhd_1_1usrp__source.html#ac1854f4d030d01967d302aba0aeb7366",
"classrpcbasic__extractor_3_01T_00_01char_01_4.html#aa70d16a157f8d09e78161cf854c5dcad",
"convolutional__interleaver_8h.html",
"form__menus_8h_source.html",
"gc__spu__macs_8h.html#a80c36ce2787745146bbd5e6f58708947",
"gr-fcd_2include_2gnuradio_2fcd_2api_8h.html",
"inttypes_8h.html#a37bbde0e3f124b7f482d54adb13b0248",
"math_8h.html#ga6c1470346a3524989b7a8a3639aa79a7",
"packet__header__default_8h_source.html",
"pmt_8h.html#a2471e5eb6c1dfeb90a3ec49a06a284ab",
"pwr__squelch__cc_8h_source.html",
"sssr__impl_8h.html",
"structvolk__func__desc.html#a56786a8661d0d8f37721e3ea670f6b2d",
"structvolk__machine.html#a6fa24dc7b7b89e3a286fe86f19bcf292",
"structvolk__machine.html#ae81f2c4010b53d3c8d9a91d7f01b8584",
"volk_8h.html#a104c20d5b1e4e32997837fd2ab982b9c",
"volk_8h.html#aa0684638787d0c48c50b3458011f6488",
"volk__32f__x2__dot__prod__16i_8h_source.html",
"volk__typedefs_8h.html#ab0687e32f29254c97537fb9159b60134"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function localStorageSupported()
{
  try {
    return 'localStorage' in window && window['localStorage'] !== null && window.localStorage.getItem;
  }
  catch(e) {
    return false;
  }
}


function storeLink(link)
{
  if (!$("#nav-sync").hasClass('sync') && localStorageSupported()) {
      window.localStorage.setItem('navpath',link);
  }
}

function deleteLink()
{
  if (localStorageSupported()) {
    window.localStorage.setItem('navpath','');
  } 
}

function cachedLink()
{
  if (localStorageSupported()) {
    return window.localStorage.getItem('navpath');
  } else {
    return '';
  }
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does not work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  var level=-1;
  var n = node;
  while (n.parentNode) { level++; n=n.parentNode; }
  var imgNode = document.createElement("img");
  imgNode.style.paddingLeft=(16*level).toString()+'px';
  imgNode.width  = 16;
  imgNode.height = 22;
  imgNode.border = 0;
  if (node.childrenData) {
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        node.plus_img.src = node.relpath+"ftv2pnode.png";
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
    imgNode.src = node.relpath+"ftv2pnode.png";
  } else {
    imgNode.src = node.relpath+"ftv2node.png";
    domNode.appendChild(imgNode);
  } 
}

var animationInProgress = false;

function gotoAnchor(anchor,aname,updateLocation)
{
  var pos, docContent = $('#doc-content');
  if (anchor.parent().attr('class')=='memItemLeft' ||
      anchor.parent().attr('class')=='fieldtype' ||
      anchor.parent().is(':header')) 
  {
    pos = anchor.parent().position().top;
  } else if (anchor.position()) {
    pos = anchor.position().top;
  }
  if (pos) {
    var dist = Math.abs(Math.min(
               pos-docContent.offset().top,
               docContent[0].scrollHeight-
               docContent.height()-docContent.scrollTop()));
    animationInProgress=true;
    docContent.animate({
      scrollTop: pos + docContent.scrollTop() - docContent.offset().top
    },Math.max(50,Math.min(500,dist)),function(){
      if (updateLocation) window.location.href=aname;
      animationInProgress=false;
    });
  }
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath($(location).attr('pathname'));
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : "javascript:void(0)"; 
      a.onclick = function(){
        storeLink(link);
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var anchor = $(aname);
        gotoAnchor(anchor,aname,true);
      };
    } else {
      a.href = url;
      a.onclick = function() { storeLink(link); }
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var aname = $(location).attr('hash');
  var anchor = $(aname);
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+
               window.location.hash.substring(1)+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parents().slice(2).prop('tagName')=='TR') {
    glowEffect(anchor.parents('div.memitem'),1000); // enum value
  } else if (anchor.parent().attr('class')=='fieldtype'){
    glowEffect(anchor.parent().parent(),1000); // struct field
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
  gotoAnchor(anchor,aname,false);
}

function selectAndHighlight(hash,n)
{
  var a;
  if (hash) {
    var link=stripPath($(location).attr('pathname'))+':'+hash.substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  if ($('#nav-tree-contents .item:first').hasClass('selected')) {
    $('#nav-sync').css('top','30px');
  } else {
    $('#nav-sync').css('top','5px');
  }
  showRoot();
}

function showNode(o, node, index, hash)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index,hash);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).show();
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1,hash);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index,hash); // retry with child node expanded
          },true);
        } else {
          var rootBase = stripPath(o.toroot.replace(/\..+$/, ''));
          if (rootBase=="index" || rootBase=="pages" || rootBase=="search") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(hash,n);
        }
      }
    }
  } else {
    selectAndHighlight(hash);
  }
}

function getNode(o, po)
{
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = $.extend(true, [], nti ? nti : navTreeSubIndices[subIndex][root]);
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0, hash);
  }
}

function navTo(o,root,hash,relpath)
{
  var link = cachedLink();
  if (link) {
    var parts = link.split('#');
    root = parts[0];
    if (parts.length>1) hash = '#'+parts[1];
    else hash='';
  }
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
    //root=root.replace(/_source\./,'.'); // source link to doc link
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (i==-1) { i=0; root=NAVTREE[0][1]; } // fallback: show index
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function showSyncOff(n,relpath)
{
    n.html('<img src="'+relpath+'sync_off.png" title="'+SYNCOFFMSG+'"/>');
}

function showSyncOn(n,relpath)
{
    n.html('<img src="'+relpath+'sync_on.png" title="'+SYNCONMSG+'"/>');
}

function toggleSyncButton(relpath)
{
  var navSync = $('#nav-sync');
  if (navSync.hasClass('sync')) {
    navSync.removeClass('sync');
    showSyncOff(navSync,relpath);
    storeLink(stripPath2($(location).attr('pathname'))+$(location).attr('hash'));
  } else {
    navSync.addClass('sync');
    showSyncOn(navSync,relpath);
    deleteLink();
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  if (localStorageSupported()) {
    var navSync = $('#nav-sync');
    if (cachedLink()) {
      showSyncOff(navSync,relpath);
      navSync.removeClass('sync');
    } else {
      showSyncOn(navSync,relpath);
    }
    navSync.click(function(){ toggleSyncButton(relpath); });
  }

  navTo(o,toroot,window.location.hash,relpath);

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath($(location).attr('pathname'))+':'+
                               $(location).attr('hash').substring(1);
         a=$('.item a[class$="'+clslink+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2($(location).attr('pathname'));
       navTo(o,link,$(location).attr('hash'),relpath);
     } else if (!animationInProgress) {
       $('#doc-content').scrollTop(0);
       $('.item').removeClass('selected');
       $('.item').removeAttr('id');
       navTo(o,toroot,window.location.hash,relpath);
     }
  })

  $(window).load(showRoot);
}

